diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/media-upload.php ./wordpress-3.3/wp-admin/media-upload.php
*** ./wordpress-3.2.1/wp-admin/media-upload.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-admin/media-upload.php	2011-11-30 22:51:35.000000000 -0600
***************
*** 18,25 ****
  if (!current_user_can('upload_files'))
  	wp_die(__('You do not have permission to upload files.'));
  
! wp_enqueue_script('swfupload-all');
! wp_enqueue_script('swfupload-handlers');
  wp_enqueue_script('image-edit');
  wp_enqueue_script('set-post-thumbnail' );
  wp_enqueue_style('imgareaselect');
--- 18,24 ----
  if (!current_user_can('upload_files'))
  	wp_die(__('You do not have permission to upload files.'));
  
! wp_enqueue_script('plupload-handlers');
  wp_enqueue_script('image-edit');
  wp_enqueue_script('set-post-thumbnail' );
  wp_enqueue_style('imgareaselect');
***************
*** 61,81 ****
  
  	$title = __('Upload New Media');
  	$parent_file = 'upload.php';
! 
! 	add_contextual_help( $current_screen,
! '<p>' . __('You can upload media files here without creating a post first. This allows you to upload files to use with posts and pages later and/or to get a web link for a particular file that you can share.') . '</p>' .
! 		'<p>' . __('There are two options for uploading files: <em>Select Files</em> will open the Flash-based uploader (multiple file upload allowed), or you can use the <em>Browser Uploader</em>. Clicking <em>Select Files</em> opens a navigation window showing you files in your operating system. Selecting <em>Open</em> after clicking on the file you want activates a progress bar on the uploader screen. Basic image editing is available after upload is complete. Make sure you click <em>Save</em> before leaving this screen.') . '</p>' .
  		'<p><strong>' . __('For more information:') . '</strong></p>' .
  		'<p>' . __('<a href="http://codex.wordpress.org/Media_Add_New_Screen" target="_blank">Documentation on Uploading Media Files</a>') . '</p>' .
  		'<p>' . __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
  	);
  
! 	require_once('./admin-header.php'); ?>
  	<div class="wrap">
  	<?php screen_icon(); ?>
  	<h2><?php echo esc_html( $title ); ?></h2>
  
! 	<form enctype="multipart/form-data" method="post" action="<?php echo admin_url('media-upload.php?inline=&amp;upload-page-form='); ?>" class="media-upload-form type-form validate" id="file-form">
  
  	<?php media_upload_form(); ?>
  
--- 60,95 ----
  
  	$title = __('Upload New Media');
  	$parent_file = 'upload.php';
! 	get_current_screen()->add_help_tab( array(
! 	'id'		=> 'overview',
! 	'title'		=> __('Overview'),
! 	'content'	=>
! 		'<p>' . __('You can upload media files here without creating a post first. This allows you to upload files to use with posts and pages later and/or to get a web link for a particular file that you can share. There are three options for uploading files:') . '</p>' .
! 		'<ul>' .
! 			'<li>' . __('<strong>Drag and drop</strong> your files into the area below. Multiple files are allowed.') . '</li>' .
! 			'<li>' . __('<strong>Select Files</strong> will open the multi-file uploader, or you can use the <strong>Browser Uploader</strong>.') . '</li>' .
! 			'<li>' . __('Clicking <strong>Select Files</strong> opens a navigation window showing you files in your operating system. Selecting <strong>Open</strong> after clicking on the file you want activates a progress bar on the uploader screen.') . '</li>' .
! 		'</ul>' .
! 		'<p>' . __('Basic image editing is available after upload is complete. Make sure you click Save before leaving this screen.') . '</p>'
! 	) );
! 	get_current_screen()->set_help_sidebar(
  		'<p><strong>' . __('For more information:') . '</strong></p>' .
  		'<p>' . __('<a href="http://codex.wordpress.org/Media_Add_New_Screen" target="_blank">Documentation on Uploading Media Files</a>') . '</p>' .
  		'<p>' . __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
  	);
  
! 	require_once('./admin-header.php');
! 
! 	$form_class = 'media-upload-form type-form validate';
! 
! 	if ( get_user_setting('uploader') )
! 		$form_class .= ' html-uploader';
! 	?>
  	<div class="wrap">
  	<?php screen_icon(); ?>
  	<h2><?php echo esc_html( $title ); ?></h2>
  
! 	<form enctype="multipart/form-data" method="post" action="<?php echo admin_url('media-upload.php?inline=&amp;upload-page-form='); ?>" class="<?php echo $form_class; ?>" id="file-form">
  
  	<?php media_upload_form(); ?>
  
***************
*** 92,99 ****
  	</script>
  	<input type="hidden" name="post_id" id="post_id" value="0" />
  	<?php wp_nonce_field('media-form'); ?>
! 	<div id="media-items" class="hide-if-no-js"> </div>
! 	<?php submit_button( __( 'Save all changes' ), 'button savebutton hide-if-no-js', 'save' ); ?>
  	</form>
  	</div>
  
--- 106,113 ----
  	</script>
  	<input type="hidden" name="post_id" id="post_id" value="0" />
  	<?php wp_nonce_field('media-form'); ?>
! 	<div id="media-items" class="hide-if-no-js"></div>
! 	<?php submit_button( __( 'Save all changes' ), 'button savebutton hidden', 'save' ); ?>
  	</form>
  	</div>
  
***************
*** 117,123 ****
  	$body_id = 'media-upload';
  
  	// let the action code decide how to handle the request
! 	if ( $tab == 'type' || $tab == 'type_url' )
  		do_action("media_upload_$type");
  	else
  		do_action("media_upload_$tab");
--- 131,137 ----
  	$body_id = 'media-upload';
  
  	// let the action code decide how to handle the request
! 	if ( $tab == 'type' || $tab == 'type_url' || ! array_key_exists( $tab , media_upload_tabs() ) )
  		do_action("media_upload_$type");
  	else
  		do_action("media_upload_$tab");
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/menu-header.php ./wordpress-3.3/wp-admin/menu-header.php
*** ./wordpress-3.2.1/wp-admin/menu-header.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-admin/menu-header.php	2011-12-05 11:47:23.000000000 -0600
***************
*** 36,122 ****
  function _wp_menu_output( $menu, $submenu, $submenu_as_parent = true ) {
  	global $self, $parent_file, $submenu_file, $plugin_page, $pagenow, $typenow;
  
- 	$menu_setting_increment = -1;
- 	$user_settings = get_all_user_settings();
- 
  	$first = true;
  	// 0 = name, 1 = capability, 2 = file, 3 = class, 4 = id, 5 = icon src
  	foreach ( $menu as $key => $item ) {
  		$admin_is_parent = false;
  		$class = array();
  		if ( $first ) {
  			$class[] = 'wp-first-item';
  			$first = false;
  		}
! 		if ( !empty($submenu[$item[2]]) ) {
  			$class[] = 'wp-has-submenu';
! 			$menu_setting_increment++;
  		}
  
  		if ( ( $parent_file && $item[2] == $parent_file ) || ( empty($typenow) && $self == $item[2] ) ) {
! 			if ( !empty($submenu[$item[2]]) )
! 				$class[] = 'wp-has-current-submenu wp-menu-open';
! 			else
! 				$class[] = 'current';
! 		} elseif ( ! empty( $submenu[ $item[2] ] ) && isset( $user_settings[ 'm' . $menu_setting_increment ] ) && 'o' == $user_settings[ 'm' . $menu_setting_increment ] ) {
! 				$class[] = 'wp-menu-open';
  		}
  
! 		if ( ! empty($item[4]) )
  			$class[] = $item[4];
  
  		$class = $class ? ' class="' . join( ' ', $class ) . '"' : '';
! 		$tabindex = ' tabindex="1"';
! 		$id = ! empty($item[5]) ? ' id="' . preg_replace( '|[^a-zA-Z0-9_:.]|', '-', $item[5] ) . '"' : '';
  		$img = '';
! 		if ( ! empty($item[6]) ) {
! 			if ( 'div' === $item[6] )
! 				$img = '<br />';
! 			else
! 				$img = '<img src="' . $item[6] . '" alt="" />';
! 		}
! 		$toggle = '<div class="wp-menu-toggle"><br /></div>';
  		$arrow = '<div class="wp-menu-arrow"><div></div></div>';
  
! 		$title = wptexturize($item[0]);
  
  		echo "\n\t<li$class$id>";
  
  		if ( false !== strpos( $class, 'wp-menu-separator' ) ) {
  			echo '<div class="separator"></div>';
! 		} elseif ( $submenu_as_parent && !empty($submenu[$item[2]]) ) {
! 			$submenu[$item[2]] = array_values($submenu[$item[2]]);  // Re-index.
! 			$menu_hook = get_plugin_page_hook($submenu[$item[2]][0][2], $item[2]);
! 			$menu_file = $submenu[$item[2]][0][2];
! 			if ( false !== $pos = strpos($menu_file, '?') )
! 				$menu_file = substr($menu_file, 0, $pos);
! 			if ( ( ('index.php' != $submenu[$item[2]][0][2]) && file_exists(WP_PLUGIN_DIR . "/$menu_file") ) || !empty($menu_hook)) {
  				$admin_is_parent = true;
! 				echo "<div class='wp-menu-image'><a href='admin.php?page={$submenu[$item[2]][0][2]}'>$img</a></div>$arrow$toggle<a href='admin.php?page={$submenu[$item[2]][0][2]}'$class$tabindex>$title</a>";
  			} else {
! 				echo "\n\t<div class='wp-menu-image'><a href='{$submenu[$item[2]][0][2]}'>$img</a></div>$arrow$toggle<a href='{$submenu[$item[2]][0][2]}'$class$tabindex>$title</a>";
  			}
! 		} else if ( !empty($item[2]) && current_user_can($item[1]) ) {
! 			$menu_hook = get_plugin_page_hook($item[2], 'admin.php');
  			$menu_file = $item[2];
! 			if ( false !== $pos = strpos($menu_file, '?') )
! 				$menu_file = substr($menu_file, 0, $pos);
! 			if ( ('index.php' != $item[2]) && file_exists(WP_PLUGIN_DIR . "/$menu_file") || !empty($menu_hook) ) {
  				$admin_is_parent = true;
! 				echo "\n\t<div class='wp-menu-image'><a href='admin.php?page={$item[2]}'>$img</a></div>$arrow$toggle<a href='admin.php?page={$item[2]}'$class$tabindex>{$item[0]}</a>";
  			} else {
! 				echo "\n\t<div class='wp-menu-image'><a href='{$item[2]}'>$img</a></div>$arrow$toggle<a href='{$item[2]}'$class$tabindex>{$item[0]}</a>";
  			}
  		}
  
! 		if ( !empty($submenu[$item[2]]) ) {
  			echo "\n\t<div class='wp-submenu'><div class='wp-submenu-wrap'>";
  			echo "<div class='wp-submenu-head'>{$item[0]}</div><ul>";
  			$first = true;
! 			foreach ( $submenu[$item[2]] as $sub_key => $sub_item ) {
! 				if ( !current_user_can($sub_item[1]) )
  					continue;
  
  				$class = array();
  				if ( $first ) {
  					$class[] = 'wp-first-item';
--- 36,117 ----
  function _wp_menu_output( $menu, $submenu, $submenu_as_parent = true ) {
  	global $self, $parent_file, $submenu_file, $plugin_page, $pagenow, $typenow;
  
  	$first = true;
  	// 0 = name, 1 = capability, 2 = file, 3 = class, 4 = id, 5 = icon src
  	foreach ( $menu as $key => $item ) {
  		$admin_is_parent = false;
  		$class = array();
+ 		$aria_attributes = 'tabindex="1"';
+ 
  		if ( $first ) {
  			$class[] = 'wp-first-item';
  			$first = false;
  		}
! 
! 		$submenu_items = false;
! 		if ( ! empty( $submenu[$item[2]] ) ) {
  			$class[] = 'wp-has-submenu';
! 			$submenu_items = $submenu[$item[2]];
  		}
  
  		if ( ( $parent_file && $item[2] == $parent_file ) || ( empty($typenow) && $self == $item[2] ) ) {
! 			$class[] = ! empty( $submenu_items ) ? 'wp-has-current-submenu wp-menu-open' : 'current';
! 		} else {
! 			$class[] = 'wp-not-current-submenu';
! 			if ( ! empty( $submenu_items ) )
! 				$aria_attributes .= ' aria-haspopup="true"';
  		}
  
! 		if ( ! empty( $item[4] ) )
  			$class[] = $item[4];
  
  		$class = $class ? ' class="' . join( ' ', $class ) . '"' : '';
! 		$id = ! empty( $item[5] ) ? ' id="' . preg_replace( '|[^a-zA-Z0-9_:.]|', '-', $item[5] ) . '"' : '';
  		$img = '';
! 		if ( ! empty( $item[6] ) )
! 			$img = ( 'div' === $item[6] ) ? '<br />' : '<img src="' . $item[6] . '" alt="" />';
  		$arrow = '<div class="wp-menu-arrow"><div></div></div>';
  
! 		$title = wptexturize( $item[0] );
  
  		echo "\n\t<li$class$id>";
  
  		if ( false !== strpos( $class, 'wp-menu-separator' ) ) {
  			echo '<div class="separator"></div>';
! 		} elseif ( $submenu_as_parent && ! empty( $submenu_items ) ) {
! 			$submenu_items = array_values( $submenu_items );  // Re-index.
! 			$menu_hook = get_plugin_page_hook( $submenu_items[0][2], $item[2] );
! 			$menu_file = $submenu_items[0][2];
! 			if ( false !== ( $pos = strpos( $menu_file, '?' ) ) )
! 				$menu_file = substr( $menu_file, 0, $pos );
! 			if ( ! empty( $menu_hook ) || ( ('index.php' != $submenu_items[0][2]) && file_exists( WP_PLUGIN_DIR . "/$menu_file" ) ) ) {
  				$admin_is_parent = true;
! 				echo "<div class='wp-menu-image'><a href='admin.php?page={$submenu_items[0][2]}'>$img</a></div>$arrow<a href='admin.php?page={$submenu_items[0][2]}'$class $aria_attributes>$title</a>";
  			} else {
! 				echo "\n\t<div class='wp-menu-image'><a href='{$submenu_items[0][2]}'>$img</a></div>$arrow<a href='{$submenu_items[0][2]}'$class $aria_attributes>$title</a>";
  			}
! 		} elseif ( ! empty( $item[2] ) && current_user_can( $item[1] ) ) {
! 			$menu_hook = get_plugin_page_hook( $item[2], 'admin.php' );
  			$menu_file = $item[2];
! 			if ( false !== ( $pos = strpos( $menu_file, '?' ) ) )
! 				$menu_file = substr( $menu_file, 0, $pos );
! 			if ( ! empty( $menu_hook ) || ( ('index.php' != $item[2]) && file_exists( WP_PLUGIN_DIR . "/$menu_file" ) ) ) {
  				$admin_is_parent = true;
! 				echo "\n\t<div class='wp-menu-image'><a href='admin.php?page={$item[2]}'>$img</a></div>$arrow<a href='admin.php?page={$item[2]}'$class $aria_attributes>{$item[0]}</a>";
  			} else {
! 				echo "\n\t<div class='wp-menu-image'><a href='{$item[2]}'>$img</a></div>$arrow<a href='{$item[2]}'$class $aria_attributes>{$item[0]}</a>";
  			}
  		}
  
! 		if ( ! empty( $submenu_items ) ) {
  			echo "\n\t<div class='wp-submenu'><div class='wp-submenu-wrap'>";
  			echo "<div class='wp-submenu-head'>{$item[0]}</div><ul>";
  			$first = true;
! 			foreach ( $submenu_items as $sub_key => $sub_item ) {
! 				if ( ! current_user_can( $sub_item[1] ) )
  					continue;
  
+ 				$aria_attributes = 'tabindex="1"';
  				$class = array();
  				if ( $first ) {
  					$class[] = 'wp-first-item';
***************
*** 125,145 ****
  
  				$menu_file = $item[2];
  
! 				if ( false !== $pos = strpos($menu_file, '?') )
! 					$menu_file = substr($menu_file, 0, $pos);
  
  				// Handle current for post_type=post|page|foo pages, which won't match $self.
! 				if ( !empty($typenow) )
! 					$self_type = $self . '?post_type=' . $typenow;
! 				else
! 					$self_type = 'nothing';
  
! 				if ( isset($submenu_file) ) {
  					if ( $submenu_file == $sub_item[2] )
  						$class[] = 'current';
  				// If plugin_page is set the parent must either match the current page or not physically exist.
  				// This allows plugin pages with the same hook to exist under different parents.
! 				} else if ( (isset($plugin_page) && $plugin_page == $sub_item[2] && (!file_exists($menu_file) || ($item[2] == $self) || ($item[2] == $self_type))) || (!isset($plugin_page) && $self == $sub_item[2]) ) {
  					$class[] = 'current';
  				}
  
--- 120,140 ----
  
  				$menu_file = $item[2];
  
! 				if ( false !== ( $pos = strpos( $menu_file, '?' ) ) )
! 					$menu_file = substr( $menu_file, 0, $pos );
  
  				// Handle current for post_type=post|page|foo pages, which won't match $self.
! 				$self_type = ! empty( $typenow ) ? $self . '?post_type=' . $typenow : 'nothing';
  
! 				if ( isset( $submenu_file ) ) {
  					if ( $submenu_file == $sub_item[2] )
  						$class[] = 'current';
  				// If plugin_page is set the parent must either match the current page or not physically exist.
  				// This allows plugin pages with the same hook to exist under different parents.
! 				} else if (
! 					( ! isset( $plugin_page ) && $self == $sub_item[2] ) ||
! 					( isset( $plugin_page ) && $plugin_page == $sub_item[2] && ( $item[2] == $self_type || $item[2] == $self || file_exists($menu_file) === false ) )
! 				) {
  					$class[] = 'current';
  				}
  
***************
*** 147,167 ****
  
  				$menu_hook = get_plugin_page_hook($sub_item[2], $item[2]);
  				$sub_file = $sub_item[2];
! 				if ( false !== $pos = strpos($sub_file, '?') )
  					$sub_file = substr($sub_file, 0, $pos);
  
  				$title = wptexturize($sub_item[0]);
  
! 				if ( ( ('index.php' != $sub_item[2]) && file_exists(WP_PLUGIN_DIR . "/$sub_file") ) || ! empty($menu_hook) ) {
  					// If admin.php is the current page or if the parent exists as a file in the plugins or admin dir
  					if ( (!$admin_is_parent && file_exists(WP_PLUGIN_DIR . "/$menu_file") && !is_dir(WP_PLUGIN_DIR . "/{$item[2]}")) || file_exists($menu_file) )
  						$sub_item_url = add_query_arg( array('page' => $sub_item[2]), $item[2] );
  					else
  						$sub_item_url = add_query_arg( array('page' => $sub_item[2]), 'admin.php' );
! 					$sub_item_url = esc_url($sub_item_url);
! 					echo "<li$class><a href='$sub_item_url'$class$tabindex>$title</a></li>";
  				} else {
! 					echo "<li$class><a href='{$sub_item[2]}'$class$tabindex>$title</a></li>";
  				}
  			}
  			echo "</ul></div></div>";
--- 142,163 ----
  
  				$menu_hook = get_plugin_page_hook($sub_item[2], $item[2]);
  				$sub_file = $sub_item[2];
! 				if ( false !== ( $pos = strpos( $sub_file, '?' ) ) )
  					$sub_file = substr($sub_file, 0, $pos);
  
  				$title = wptexturize($sub_item[0]);
  
! 				if ( ! empty( $menu_hook ) || ( ('index.php' != $sub_item[2]) && file_exists( WP_PLUGIN_DIR . "/$sub_file" ) ) ) {
  					// If admin.php is the current page or if the parent exists as a file in the plugins or admin dir
  					if ( (!$admin_is_parent && file_exists(WP_PLUGIN_DIR . "/$menu_file") && !is_dir(WP_PLUGIN_DIR . "/{$item[2]}")) || file_exists($menu_file) )
  						$sub_item_url = add_query_arg( array('page' => $sub_item[2]), $item[2] );
  					else
  						$sub_item_url = add_query_arg( array('page' => $sub_item[2]), 'admin.php' );
! 
! 					$sub_item_url = esc_url( $sub_item_url );
! 					echo "<li$class><a href='$sub_item_url'$class $aria_attributes>$title</a></li>";
  				} else {
! 					echo "<li$class><a href='{$sub_item[2]}'$class $aria_attributes>$title</a></li>";
  				}
  			}
  			echo "</ul></div></div>";
***************
*** 179,185 ****
  <div id="adminmenuback"></div>
  <div id="adminmenuwrap">
  <div id="adminmenushadow"></div>
! <ul id="adminmenu">
  
  <?php
  
--- 175,181 ----
  <div id="adminmenuback"></div>
  <div id="adminmenuwrap">
  <div id="adminmenushadow"></div>
! <ul id="adminmenu" role="navigation">
  
  <?php
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/menu.php ./wordpress-3.3/wp-admin/menu.php
*** ./wordpress-3.2.1/wp-admin/menu.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-admin/menu.php	2011-11-18 02:43:16.000000000 -0600
***************
*** 30,74 ****
  	$submenu[ 'index.php' ][5] = array( __('My Sites'), 'read', 'my-sites.php' );
  }
  
! if ( ! is_multisite() || is_super_admin() ) {
! 	$plugin_update_count = $theme_update_count = $wordpress_update_count = 0;
! 
! 	if ( current_user_can( 'update_plugins' ) ) {
! 		$update_plugins = get_site_transient( 'update_plugins' );
! 		if ( ! empty( $update_plugins->response ) )
! 			$plugin_update_count = count( $update_plugins->response );
! 	}
! 
! 	if ( current_user_can( 'update_themes' ) ) {
! 		$update_themes = get_site_transient( 'update_themes' );
! 		if ( !empty($update_themes->response) )
! 			$theme_update_count = count( $update_themes->response );
! 	}
! 
! 	if ( current_user_can( 'update_core' ) ) {
! 		$update_wordpress = get_core_updates( array('dismissed' => false) );
! 		if ( !empty($update_wordpress) && !in_array( $update_wordpress[0]->response, array('development', 'latest') ) && current_user_can('update_core') )
! 			$wordpress_update_count = 1;
! 	}
! 
! 	$total_update_count = $plugin_update_count + $theme_update_count + $wordpress_update_count;
! 	$update_title = array();
! 	if ( $wordpress_update_count )
! 		$update_title[] = sprintf(__('%d WordPress Update'), $wordpress_update_count);
! 	if ( $plugin_update_count )
! 		$update_title[] = sprintf(_n('%d Plugin Update', '%d Plugin Updates', $plugin_update_count), $plugin_update_count);
! 	if ( $theme_update_count )
! 		$update_title[] = sprintf(_n('%d Theme Update', '%d Theme Updates', $theme_update_count), $theme_update_count);
! 
! 	$update_title = !empty($update_title) ? esc_attr(implode(', ', $update_title)) : '';
! }
  
  if ( ! is_multisite() ) {
! 	$submenu[ 'index.php' ][10] = array( sprintf( __('Updates %s'), "<span class='update-plugins count-$total_update_count' title='$update_title'><span class='update-count'>" . number_format_i18n($total_update_count) . "</span></span>" ), 'update_core',  'update-core.php');
  }
  
- unset($theme_update_count, $wordpress_update_count, $update_themes, $update_plugins, $update_wordpress);
- 
  $menu[4] = array( '', 'read', 'separator1', '', 'wp-menu-separator' );
  
  $menu[5] = array( __('Posts'), 'edit_posts', 'edit.php', '', 'open-if-no-js menu-top menu-icon-post', 'menu-posts', 'div' );
--- 30,42 ----
  	$submenu[ 'index.php' ][5] = array( __('My Sites'), 'read', 'my-sites.php' );
  }
  
! if ( ! is_multisite() || is_super_admin() )
! 	$update_data = wp_get_update_data();
  
  if ( ! is_multisite() ) {
! 	$submenu[ 'index.php' ][10] = array( sprintf( __('Updates %s'), "<span class='update-plugins count-{$update_data['counts']['total']}' title='{$update_data['title']}'><span class='update-count'>" . number_format_i18n($update_data['counts']['total']) . "</span></span>" ), 'update_core',  'update-core.php');
  }
  
  $menu[4] = array( '', 'read', 'separator1', '', 'wp-menu-separator' );
  
  $menu[5] = array( __('Posts'), 'edit_posts', 'edit.php', '', 'open-if-no-js menu-top menu-icon-post', 'menu-posts', 'div' );
***************
*** 88,97 ****
  $menu[10] = array( __('Media'), 'upload_files', 'upload.php', '', 'menu-top menu-icon-media', 'menu-media', 'div' );
  	$submenu['upload.php'][5] = array( __('Library'), 'upload_files', 'upload.php');
  	/* translators: add new file */
! 	$submenu['upload.php'][10] = array( _x('Add New', 'file'), 'upload_files', 'media-new.php');
  
  $menu[15] = array( __('Links'), 'manage_links', 'link-manager.php', '', 'menu-top menu-icon-links', 'menu-links', 'div' );
! 	$submenu['link-manager.php'][5] = array( __('All Links'), 'manage_links', 'link-manager.php' );
  	/* translators: add new links */
  	$submenu['link-manager.php'][10] = array( _x('Add New', 'link'), 'manage_links', 'link-add.php' );
  	$submenu['link-manager.php'][15] = array( __('Link Categories'), 'manage_categories', 'edit-tags.php?taxonomy=link_category' );
--- 56,66 ----
  $menu[10] = array( __('Media'), 'upload_files', 'upload.php', '', 'menu-top menu-icon-media', 'menu-media', 'div' );
  	$submenu['upload.php'][5] = array( __('Library'), 'upload_files', 'upload.php');
  	/* translators: add new file */
! 	if ( !$is_iphone )
! 		$submenu['upload.php'][10] = array( _x('Add New', 'file'), 'upload_files', 'media-new.php');
  
  $menu[15] = array( __('Links'), 'manage_links', 'link-manager.php', '', 'menu-top menu-icon-links', 'menu-links', 'div' );
! 	$submenu['link-manager.php'][5] = array( _x('All Links', 'admin menu'), 'manage_links', 'link-manager.php' );
  	/* translators: add new links */
  	$submenu['link-manager.php'][10] = array( _x('Add New', 'link'), 'manage_links', 'link-add.php' );
  	$submenu['link-manager.php'][15] = array( __('Link Categories'), 'manage_categories', 'edit-tags.php?taxonomy=link_category' );
***************
*** 166,172 ****
  			$submenu['themes.php'][10] = array(__('Menus'), 'edit_theme_options', 'nav-menus.php' );
  }
  
! // Add 'Editor' to the bottom of the Appearence menu.
  if ( ! is_multisite() )
  	add_action('admin_menu', '_add_themes_utility_last', 101);
  function _add_themes_utility_last() {
--- 135,141 ----
  			$submenu['themes.php'][10] = array(__('Menus'), 'edit_theme_options', 'nav-menus.php' );
  }
  
! // Add 'Editor' to the bottom of the Appearance menu.
  if ( ! is_multisite() )
  	add_action('admin_menu', '_add_themes_utility_last', 101);
  function _add_themes_utility_last() {
***************
*** 176,184 ****
  
  $menu_perms = get_site_option( 'menu_items', array() );
  if ( ! is_multisite() || is_super_admin() || ! empty( $menu_perms['plugins'] ) ) {
  	$count = '';
  	if ( ! is_multisite() && current_user_can( 'update_plugins' ) )
! 		$count = "<span class='update-plugins count-$plugin_update_count'><span class='plugin-count'>" . number_format_i18n($plugin_update_count) . "</span></span>";
  
  	$menu[65] = array( sprintf( __('Plugins %s'), $count ), 'activate_plugins', 'plugins.php', '', 'menu-top menu-icon-plugins', 'menu-plugins', 'div' );
  
--- 145,156 ----
  
  $menu_perms = get_site_option( 'menu_items', array() );
  if ( ! is_multisite() || is_super_admin() || ! empty( $menu_perms['plugins'] ) ) {
+ 	if ( ! isset( $update_data ) )
+ 		$update_data = wp_get_update_data();
+ 
  	$count = '';
  	if ( ! is_multisite() && current_user_can( 'update_plugins' ) )
! 		$count = "<span class='update-plugins count-{$update_data['counts']['plugins']}'><span class='plugin-count'>" . number_format_i18n($update_data['counts']['plugins']) . "</span></span>";
  
  	$menu[65] = array( sprintf( __('Plugins %s'), $count ), 'activate_plugins', 'plugins.php', '', 'menu-top menu-icon-plugins', 'menu-plugins', 'div' );
  
***************
*** 190,196 ****
  			$submenu['plugins.php'][15] = array( _x('Editor', 'plugin editor'), 'edit_plugins', 'plugin-editor.php' );
  		}
  }
! unset($menu_perms, $update_plugins, $plugin_update_count);
  
  if ( current_user_can('list_users') )
  	$menu[70] = array( __('Users'), 'list_users', 'users.php', '', 'menu-top menu-icon-users', 'menu-users', 'div' );
--- 162,168 ----
  			$submenu['plugins.php'][15] = array( _x('Editor', 'plugin editor'), 'edit_plugins', 'plugin-editor.php' );
  		}
  }
! unset($menu_perms, $update_data);
  
  if ( current_user_can('list_users') )
  	$menu[70] = array( __('Users'), 'list_users', 'users.php', '', 'menu-top menu-icon-users', 'menu-users', 'div' );
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/my-sites.php ./wordpress-3.3/wp-admin/my-sites.php
*** ./wordpress-3.2.1/wp-admin/my-sites.php	2011-11-24 20:39:25.000000000 -0600
--- ./wordpress-3.3/wp-admin/my-sites.php	2011-11-30 20:22:07.000000000 -0600
***************
*** 17,26 ****
  
  $action = isset( $_POST['action'] ) ? $_POST['action'] : 'splash';
  
! $blogs = get_blogs_of_user( $current_user->id );
! 
! if ( empty( $blogs ) )
! 	wp_die( __( 'You must be a member of at least one site to use this page.' ) );
  
  $updated = false;
  if ( 'updateblogsettings' == $action && isset( $_POST['primary_blog'] ) ) {
--- 17,23 ----
  
  $action = isset( $_POST['action'] ) ? $_POST['action'] : 'splash';
  
! $blogs = get_blogs_of_user( $current_user->ID );
  
  $updated = false;
  if ( 'updateblogsettings' == $action && isset( $_POST['primary_blog'] ) ) {
***************
*** 28,34 ****
  
  	$blog = get_blog_details( (int) $_POST['primary_blog'] );
  	if ( $blog && isset( $blog->domain ) ) {
! 		update_user_option( $current_user->id, 'primary_blog', (int) $_POST['primary_blog'], true );
  		$updated = true;
  	} else {
  		wp_die( __( 'The primary site you chose does not exist.' ) );
--- 25,31 ----
  
  	$blog = get_blog_details( (int) $_POST['primary_blog'] );
  	if ( $blog && isset( $blog->domain ) ) {
! 		update_user_option( $current_user->ID, 'primary_blog', (int) $_POST['primary_blog'], true );
  		$updated = true;
  	} else {
  		wp_die( __( 'The primary site you chose does not exist.' ) );
***************
*** 38,46 ****
  $title = __( 'My Sites' );
  $parent_file = 'index.php';
  
! add_contextual_help($current_screen,
! 	'<p>' . __('This screen shows an individual user all of their sites in this network, and also allows that user to set a primary site. He or she can use the links under each site to visit either the frontend or the dashboard for that site.') . '</p>' .
! 	'<p>' . __('Up until WordPress version 3.0, what is now called a Multi-site Network had to be installed separately as WordPress MU (multi-user).') . '</p>' .
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Dashboard_My_Sites_Screen" target="_blank">Documentation on My Sites</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
--- 35,49 ----
  $title = __( 'My Sites' );
  $parent_file = 'index.php';
  
! get_current_screen()->add_help_tab( array(
! 	'id'      => 'overview',
! 	'title'   => __('Overview'),
! 	'content' =>
! 		'<p>' . __('This screen shows an individual user all of their sites in this network, and also allows that user to set a primary site. He or she can use the links under each site to visit either the frontend or the dashboard for that site.') . '</p>' .
! 		'<p>' . __('Up until WordPress version 3.0, what is now called a Multisite Network had to be installed separately as WordPress MU (multi-user).') . '</p>'
! ) );
! 
! get_current_screen()->set_help_sidebar(
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Dashboard_My_Sites_Screen" target="_blank">Documentation on My Sites</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
***************
*** 55,60 ****
--- 58,70 ----
  <div class="wrap">
  <?php screen_icon(); ?>
  <h2><?php echo esc_html( $title ); ?></h2>
+ <?php
+ if ( empty( $blogs ) ) :
+ 	echo '<p>';
+ 	_e( 'You must be a member of at least one site to use this page.' );
+ 	echo '</p>';
+ else :
+ ?>
  <form id="myblogs" action="" method="post">
  	<?php
  	choose_primary_blog();
***************
*** 104,109 ****
--- 114,120 ----
  	<?php wp_nonce_field( 'update-my-sites' ); ?>
  	<?php submit_button(); ?>
  	</form>
+ <?php endif; ?>
  	</div>
  <?php
  include( './admin-footer.php' );
